<template>
  <div class="d-f facsimile">
    <div class="facsimile__steps">
      <div class="facsimile__steps--step">
        <div class="top">
          <div class="num">
            <span>1</span>
          </div>
          <div class="text">
            Отсканируйте любой документ <br/>
            с нужной подписью и печатью <br/>
            в формате png или jpg
          </div>
        </div>
        <!--<div class="link">-->
        <!--Скачать бланк-пустографку-->
        <!--</div>-->
      </div>
      <div class="facsimile__steps--step">
        <div class="top">
          <div class="num">
            <span>2</span>
          </div>
          <div class="text">
            Откройте полученный скан в любом <br/>
            приложении, позволяющем <br/>
            вырезать часть картинки. Например, <br/>
            в стандартной программе <br/>
            просмотра картинок Windows <br/>
            или Mac
          </div>
        </div>
      </div>
      <div class="facsimile__steps--step">
        <div class="top">
          <div class="num">
            <span>3</span>
          </div>
          <div class="text">
            Вырежьте две отдельных <br/>
            квадратных картинки: одну <br/>
            с подписью, другую с печатью
          </div>
        </div>
      </div>
      <div class="facsimile__steps--step">
        <div class="top">
          <div class="num">
            <span>4</span>
          </div>
          <div class="text">
            Cохраните вырезанные картинки <br/>
            в формате png или jpg
          </div>
        </div>
      </div>
      <div class="facsimile__steps--step">
        <div class="top">
          <div class="num">
            <span>5</span>
          </div>
          <div class="text">
            Перетащите картинки с подписью <br/>
            и печатью в соответствующие <br/>
            области справа
          </div>
        </div>
      </div>
      <div class="facsimile__steps--step">
        <div class="top">
          <div class="num">
            <span>6</span>
          </div>
          <div class="text">
            Проверьте получившиеся <br/>
            изображения факсимиле
          </div>
        </div>
      </div>
    </div>
    <div class="facsimile__images">
      <div class="facsimile__images--title">
        Ваши факсимиле
      </div>
      <div class="facsimile__images--line">
        <div class="facsimile__images--line-item">
          <div class="text">Подпись руководителя </div>
          <div v-if="facsimile.signatureUuid && facsimileImages.signatureUuid && facsimileImages.signatureUuid.url">
            <div :style="'background-image: url(' + facsimileImages.signatureUuid.url + ');'"
                 class="image">
            </div >
            <div class="facsimile__images--delete">
              <div @click="onClearFacsimile('signatureUuid')"
                   class="delete">
                Удалить
              </div>
            </div>
          </div>
          <div v-else>
            <ob-uploader
                data-qa="uploader"
                label="Перетащите сюда картинку с подписью или нажмите"
                :multiple="false"
                @change="onUploadFile($event, 'signatureUuid')"
            />
          </div>
        </div>
        <div class="facsimile__images--line-item">
          <div class="text">Печать руководителя</div>
          <div v-if="facsimile.stampUuid && facsimileImages.stampUuid && facsimileImages.stampUuid.url">
            <div :style="'background-image: url(' + facsimileImages.stampUuid.url + ');'"
                 class="image">
            </div>
            <div class="facsimile__images--delete">
              <div @click="onClearFacsimile('stampUuid')"
                   class="delete">
                Удалить
              </div>
            </div>
          </div>
          <div v-else>
            <ob-uploader
                data-qa="uploader"
                label="Перетащите сюда картинку с печатью или нажмите"
                :multiple="false"
                @change="onUploadFile($event, 'stampUuid')"
            />
          </div>

        </div>
      </div>
      <div class="facsimile__images--line mt40">
        <div class="facsimile__images--line-item">
          <div class="text">Подпись главного бухгалтера</div>
          <div v-if="facsimile.accountantSignatureUuid && facsimileImages.accountantSignatureUuid && facsimileImages.accountantSignatureUuid.url">
            <div :style="'background-image: url(' + facsimileImages.accountantSignatureUuid.url + ');'"
                 class="image">
            </div >
            <div class="facsimile__images--delete">
              <div @click="onClearFacsimile('accountantSignatureUuid')"
                   class="delete">
                Удалить
              </div>
            </div>
          </div>
          <div v-else>
            <ob-uploader
                data-qa="uploader"
                label="Перетащите сюда картинку с подписью или нажмите"
                :multiple="false"
                @change="onUploadFile($event, 'accountantSignatureUuid')"
            />
          </div>
        </div>
        <div class="facsimile__images--line-item">
          <div class="text">Печать главного бухгалтера</div>
          <div v-if="facsimile.accountantStampUuid && facsimileImages.accountantStampUuid && facsimileImages.accountantStampUuid.url">
            <div :style="'background-image: url(' + facsimileImages.accountantStampUuid.url + ');'"
                 class="image">
            </div>
            <div class="facsimile__images--delete">
              <div @click="onClearFacsimile('accountantStampUuid')"
                   class="delete">
                Удалить
              </div>
            </div>
          </div>
          <div v-else>
            <ob-uploader
                data-qa="uploader"
                label="Перетащите сюда картинку с печатью или нажмите"
                :multiple="false"
                @change="onUploadFile($event, 'accountantStampUuid')"
            />
          </div>

        </div>
      </div>
      <div v-if="isExistOneFacsimile"
           class="facsimile__images--delete">
        <div class="text">
          Чтобы заменить факсимиле, просто перетащите новую картинку <br/>
          поверх старой или удалите старую картинку и загрузите новую
        </div>
      </div>
    </div>
    <ConfirmDeleteModal
      ref="confirmDeleteModal"
    />
  </div>
</template>

<script>
  import ConfirmDeleteModal from './confirmDeleteModal'
  import ObUploader from 'common-components/src/obComponents/obUploader'
  import { mapActions, mapGetters } from "vuex"
  import api from "@/api"

  export default {
    name: "ParticipantCardFacsimile",
    components:{
      ObUploader,
      ConfirmDeleteModal
    },
    mounted () {
      this.getFacsimile()
    },
    computed:{
      ...mapGetters({
        userUuid: 'user/participantUuid',
        facsimile: 'clicarSettings_2/facsimile',
        facsimileImages: 'clicarSettings_2/facsimileImages',
        role: 'user/role'
      }),
      isExistOneFacsimile () {
        return Boolean(Object.values(this.facsimile).find(item => Boolean(item)))
      }
    },
    methods:{
      ...mapActions({
        getFacsimile: 'clicarSettings_2/getFacsimile',
        saveFacsimile: 'clicarSettings_2/saveFacsimile'
      }),
      async onUploadFile(data, type) {
        data = data[0]

        await api.files.postFile({
          uuid: data.uuid,
          file: data.file,
          participant_uuid: this.userUuid
        })

        await this.saveFacsimile({ type, fileUuid: data.uuid })
      },

      async onClearFacsimile (type) {
        this.$refs.confirmDeleteModal.open({ type })
      }
    }
  }
</script>

<style scoped lang="scss">
  @import '~common-components/src/static/css/mixins';
  .facsimile {
    margin: 30px;
    .mt40 {
      margin-top: 40px!important;
    }
    &__steps {
      padding-right: 40px;
      border-right: 1px $blue-150 solid;
      &--step {
        margin-bottom: 40px;
        .top {
          display: flex;
          .num {
            min-width: 36px;
            width: 36px;
            height: 36px;
            display: flex;
            align-items: center;
            justify-content: center;
            border: 2px solid $color-blue-smalt;
            border-radius: 20px;
            margin-right: 20px;
            @include font-mixin(16px, 19px, 700, $color-blue-smalt);
          }
          .text {
            @include font-mixin(16px, 20px, 400);
          }
        }
        .link {
          cursor: pointer;
          margin: 10px 0 0 56px;
          @include font-mixin(16px, 20px, 400, $color-blue-smalt);
        }
      }
    }
    &__images {
      padding-left: 40px;
      &--title {
        @include font-mixin(20px, 28px, 700);
      }
      &--line {
        display: flex;
        margin-top: 30px;
        &-item {
          width: 198px;
          margin-right: 20px;
          .text {
            margin-bottom: 10px;
            @include font-mixin(16px, 20px, 400);
          }
          .image {
            width: 198px;
            height: 198px;
            display: flex;
            align-items: center;
            justify-content: center;
            text-align: center;
            border: 1px dashed $obUploader-body_border_color;
            background-size: contain;
            background-position: center center;
            background-repeat: no-repeat;
            @include font-mixin(12px, 18px, 400, $color-grey-label);
          }
        }
      }
      &--delete {
        margin-top: 10px;
        .delete {
          @include font-mixin(14px, 18px, 400, $color-error);
          cursor: pointer;
        }
        .text {
          margin-top: 30px;
          @include font-mixin(12px, 14px, 400, $gray-slate);
        }
      }
    }
  }
  ::v-deep {
    .ob-uploader-body {
      width: 198px;
      height: 198px;
      display: flex;
      align-items: center;
      justify-content: center;
      text-align: center;
      border: 1px dashed $obUploader-body_border_color;
      @include font-mixin(12px, 18px, 400, $color-grey-label);
    }
    .ob-uploader__chip {
      display: none;
    }
  }
</style>
